/**
 * DREAM
 * Copyright (C) 2003 2004 INRIA Rhone-Alpes
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *******************************************************************************
 * BASED ON :
 * Fractal ADL Parser
 * Copyright (C) 2002-2004 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: Eric.Bruneton@rd.francetelecom.com
 *
 * Author: Eric Bruneton
 *******************************************************************************
 *
 * Contact: dream@objectweb.org
 */

import java.util.HashMap;

import org.objectweb.dream.adl.FactoryFactory;
import org.objectweb.dream.adl.ReconfigurationFactory;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.util.Fractal;

/**
 * Entry point
 */
public class Helloworld
{

  public static void main(String[] args) throws Exception
  {
    Component hw = (Component) FactoryFactory.getFactory().newComponent(
        "HelloWorld", new HashMap());
    Fractal.getLifeCycleController(hw).startFc();
    System.out.println("Call Run method");
    new Thread(new HWTheread((Runnable) hw.getFcInterface("r"))).start();
    Thread.sleep(2000);
    
    System.out.println("Stop component");
    Fractal.getLifeCycleController(hw).stopFc();
    System.out.println("Reconfigure component");
    ReconfigurationFactory.getReconfiguration().addComponents(hw,
        "ReconfHelloWorld", new HashMap());
    System.out.println("Restart component");
    Fractal.getLifeCycleController(hw).startFc();
  }

  static class HWTheread implements Runnable
  {

    Runnable runItf;

    HWTheread(Runnable runItf)
    {
      this.runItf = runItf;
    }

    public void run()
    {
      while (true)
      {
        runItf.run();
        System.out.println();
        try
        {
          Thread.sleep(1000);
        }
        catch (InterruptedException e)
        {
          e.printStackTrace();
        }
      }
    }
  }
}